> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Check Repository Access

> Checks if a principal has read access to a repository.

`Unary` · [`Runners`](https://ona.com/docs/api-reference/generated/runner/overview)

Checks if a principal has read access to a repository.

Use this method to:

* Validate repository access before workflow execution
* Verify executor credentials for automation bindings

Returns:

* has\_access: true if the principal can read the repository
* FAILED\_PRECONDITION if authentication is required
* INVALID\_ARGUMENT if the repository URL is invalid

### Examples

* Check access:

  Verifies read access to a repository.

  ```yaml theme={null}
  runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  repositoryUrl: "https://github.com/org/repo"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.RunnerService/CheckRepositoryAccess
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.RunnerService/CheckRepositoryAccess" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "runnerId": "<runner-id>"
}'
```

```python Python theme={null}
import gitpod.v1.runner_pb2 as runner_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = runner_pb2.CheckRepositoryAccessRequest(
    runner_id="<runner-id>",
)
response = ona.services.runner.check_repository_access(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { CheckRepositoryAccessRequestSchema } from "@gitpod/sdk/gitpod/v1/runner_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(CheckRepositoryAccessRequestSchema, {
    runnerId: "<runner-id>",
  });
  const response = await ona.services.runner.checkRepositoryAccess(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.CheckRepositoryAccessRequest{
		RunnerId: "<runner-id>",
	})
	response, err := ona.Services.Runner.CheckRepositoryAccess(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "runnerId": "<runner-id>"
}
```

## Request

`gitpod.v1.CheckRepositoryAccessRequest`

| Field | Type | Required | Description |
| - | - | - | - |
| `runnerId` | string | No | Constraints: `string.uuid=true`. |
| `repositoryUrl` | string | No | repository\_url is the URL of the repository to check access for. Can be a clone URL ([https://github.com/org/repo.git](https://github.com/org/repo.git)) or web URL ([https://github.com/org/repo](https://github.com/org/repo)). Constraints: `string.uri=true`. |

## Response

`gitpod.v1.CheckRepositoryAccessResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `hasAccess` | boolean | No | has\_access indicates whether the principal has read access to the repository. |
| `errorMessage` | string | No | error\_message provides details when access check fails. Empty when has\_access is true. |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.